import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'assessment' },
})
export class Assessment extends BaseModel {
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表：patent_assessment_status',
  })
  status: string;
  @prop({ required: false, index: true, zh: '管理员id' })
  admin_id: string;
  @prop({ required: false, index: true, zh: '管理员姓名' })
  admin_name: string;
  @prop({ required: false, index: true, zh: '用户id' })
  user_id: string;
  @prop({ required: false, index: true, zh: '用户姓名' })
  user_name: string;
  @prop({ required: false, index: true, zh: '专利id' })
  patent_id: string;
  @prop({ required: false, index: true, zh: '申请号' })
  create_number: string;
  @prop({ required: false, index: true, zh: '专利名称' })
  patent_name: string;
  @prop({ required: false, index: true, zh: '发明人' })
  inventor: string;
  @prop({
    required: false,
    index: true,
    zh: '专利类型',
    remark: '字典表：patent_type',
  })
  type: string;
  @prop({ required: false, index: true, zh: '联系人' })
  contact: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: false, zh: '摘要' })
  abstract: string;
  @prop({ required: false, index: false, zh: '应用领域' })
  field: string;
  @prop({ required: false, index: false, zh: '技术说明' })
  explain: string;
  @prop({ required: false, index: false, zh: '合享价值度' })
  shared_value: string;
  @prop({ required: false, index: false, zh: '技术稳定性' })
  techol_stable: string;
  @prop({ required: false, index: false, zh: '技术先进性' })
  techol_advanced: string;
  @prop({
    required: false,
    index: true,
    zh: '是否缴费',
    remark: '字典表：common_isno',
    default: '1',
  })
  is_money: string;
  @prop({ required: false, index: false, zh: '审核记录' })
  record: Array<any>;
  @prop({ required: false, index: false, zh: '报告文件' })
  report_file: Array<any>;
}
