import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'cpcMessage' },
})
export class CpcMessage extends BaseModel {
  @prop({ required: false, index: true, zh: '接收人' })
  receive_id: string;
  @prop({ required: false, index: true, zh: '接收人姓名' })
  receive_name: string;
  @prop({ required: false, index: true, zh: '专利id' })
  patent_id: string;
  @prop({ required: false, index: true, zh: '申请号' })
  create_number: string;
  @prop({ required: false, index: true, zh: '专利名称' })
  patent_name: string;
  @prop({ required: false, index: false, zh: '预警信息' })
  content: string;
  @prop({ required: false, index: false, zh: '预警文件' })
  warn_file: Array<any>;
  @prop({ required: false, index: true, zh: '发送时间' })
  send_date: string;
  @prop({ required: false, index: true, zh: '是否已读', default: '0' })
  is_read: string;
}
