import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'patent' },
})
export class Patent extends BaseModel {
  @prop({ required: false, index: true, zh: '申请号' })
  create_number: string;
  @prop({ required: false, index: true, zh: '申请日' })
  create_date: string;
  @prop({ required: false, index: true, zh: '公开(公告)号' })
  success_number: string;
  @prop({ required: false, index: true, zh: '公开(公告)日' })
  success_date: string;
  @prop({ required: false, index: true, zh: '发明人' })
  inventor: string;
  @prop({ required: false, index: false, zh: '代理机构' })
  agent: string;
  @prop({ required: false, index: false, zh: '代理人' })
  agent_personal: string;
  @prop({ required: false, index: false, zh: '摘要(中文)' })
  abstract: string;
  @prop({ required: false, index: true, zh: '发明人地址' })
  address: string;
  @prop({ required: false, index: true, zh: '标题(中文)' })
  name: string;
  @prop({ required: false, index: true, zh: '申请人' })
  apply_personal: string;
  @prop({
    required: false,
    index: true,
    zh: '专利有效性',
    remark: '字典：patent_term',
  })
  term: string;
  @prop({
    required: false,
    index: true,
    zh: '专利类型',
    remark: '字典：patent_type',
  })
  type: string;
  @prop({ required: false, index: false, zh: '首页附图(压缩图)' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '公开国别' })
  nationality: string;
  @prop({ required: false, index: false, zh: 'IPC主分类' })
  ipc_type: string;
  @prop({ required: false, index: false, zh: '当前法律状态' })
  onlegal_status: string;
  @prop({ required: false, index: false, zh: '法律状态' })
  legal_status: string;
  @prop({ required: false, index: false, zh: '法律文书日期' })
  law_date: string;
  @prop({ required: false, index: false, zh: '当前权利人' })
  on_obligee: string;
  @prop({ required: false, index: false, zh: '申请人地址(其他)' })
  apply_address: string;
  @prop({ required: false, index: false, zh: '申请人(其他)' })
  apply_other: string;
  @prop({ required: false, index: false, zh: '法律文书编号' })
  law_num: string;
  @prop({ required: false, index: false, zh: '首次公开日' })
  first_opendate: string;
  @prop({ required: false, index: false, zh: '授权公告日' })
  empower_date: string;
  @prop({ required: false, index: false, zh: '失效日' })
  lose_date: string;
  @prop({ required: false, index: false, zh: '实质审查生效日' })
  examine_date: string;
  @prop({ required: false, index: false, zh: '发明(设计)人(其他)' })
  invention_design: string;
  @prop({ required: false, index: false, zh: '链接到incoPat' })
  incopat_link: string;
  @prop({ required: false, index: false, zh: '首项权利要求' })
  first_ask: string;
  @prop({ required: false, index: true, zh: '第一申请人' })
  first_apply: string;
  @prop({ required: false, index: false, zh: '中国申请人城市' })
  apply_city: string;
  @prop({ required: false, index: false, zh: '工商统一社会信用代码' })
  business_code: string;
  @prop({ required: false, index: false, zh: '工商注册地' })
  business_address: string;
  @prop({ required: false, index: true, zh: '第一发明人' })
  first_inventor: string;
  @prop({ required: false, index: false, zh: '合享价值度' })
  shared_value: string;
  @prop({ required: false, index: false, zh: '技术稳定性' })
  techol_stable: string;
  @prop({ required: false, index: false, zh: '技术先进性' })
  techol_advanced: string;
  @prop({ required: false, index: false, zh: 'PCT国际申请号' })
  pct_apply: string;
  @prop({ required: false, index: false, zh: 'PCT国际公布号' })
  pct_publish: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典：common_status',
    default: '0',
  })
  status: string;
  @prop({
    required: false,
    index: true,
    zh: '交易状态',
    remark: '字典：common_status',
    default: '0',
  })
  trans_status: string;
  @prop({ required: false, index: false, zh: '专利关联人' })
  users: Array<any>;
}
