import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'safeg' },
})
export class Safeg extends BaseModel {
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表：patent_safeg_status',
    default: '0',
  })
  status: string;
  @prop({ required: false, index: true, zh: '管理员id' })
  admin_id: string;
  @prop({ required: false, index: true, zh: '管理员姓名' })
  admin_name: string;
  @prop({ required: false, index: true, zh: '用户id' })
  user_id: string;
  @prop({ required: false, index: true, zh: '用户姓名' })
  user_name: string;
  @prop({ required: false, index: true, zh: '专利id' })
  patent_id: string;
  @prop({ required: false, index: true, zh: '专利名称' })
  patent_name: string;
  @prop({ required: false, index: true, zh: '申请号' })
  create_number: string;
  @prop({ required: false, index: true, zh: '申请人' })
  apply_name: string;
  @prop({
    required: false,
    index: true,
    zh: '专利类型',
    remark: '字典：patent_type',
  })
  type: string;
  @prop({ required: false, index: true, zh: '发明人' })
  inventor: string;
  @prop({ required: false, index: true, zh: '联系人' })
  contact: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: false, zh: '诉求' })
  appeal: string;
  @prop({ required: false, index: false, zh: '侵权事实' })
  infringement: string;
  @prop({ required: false, index: false, zh: '本发明的技术领域' })
  techol_field: string;
  @prop({ required: false, index: false, zh: '本发明的相关的背景技术' })
  techol_back: string;
  @prop({
    required: false,
    index: false,
    zh: '现有技术的缺点及本发明所要解决的技术问题',
  })
  techol_ques: string;
  @prop({ required: false, index: false, zh: '本发明技术方案的详细阐述' })
  techol_prop: string;
  @prop({ required: false, index: false, zh: '本申请的关键点和预保护点' })
  techol_prot: string;
  @prop({
    required: false,
    index: false,
    zh: '本发明最相似，相近的实现技术，方案相比，本发明有何优点',
  })
  techol_advan: string;
  @prop({
    required: false,
    index: false,
    zh: '针对本发明技术方案，是否还有的替代方案',
  })
  techol_alter: string;
  @prop({ required: false, index: false, zh: '审核记录' })
  record: Array<any>;
  @prop({ required: false, index: false, zh: '报告文件' })
  report_file: Array<any>;
}
