import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'techol' },
})
export class Techol extends BaseModel {
  @prop({ required: false, index: true, zh: '需求订单号' })
  order_num: string;
  @prop({ required: false, index: true, zh: '需求描述（用途）' })
  describe: string;
  @prop({
    required: false,
    index: true,
    zh: '紧急程度',
    remark: '字典：patent_tecol_urgent',
  })
  urgent: string;
  @prop({ required: false, index: true, zh: '联系人' })
  contact: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: false, zh: '合作条件及要求' })
  requirement: string;
  @prop({ required: false, index: true, zh: '状态' })
  status: string;
}
