import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'transtion' },
})
export class Transtion extends BaseModel {
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典：patent_trans_status',
  })
  status: string;
  @prop({ required: false, index: true, zh: '机构id' })
  mech_id: string;
  @prop({ required: false, index: true, zh: '机构名称' })
  mech_name: string;
  @prop({ required: false, index: true, zh: '用户id' })
  user_id: string;
  @prop({ required: false, index: true, zh: '用户姓名' })
  user_name: string;
  @prop({ required: false, index: true, zh: '专利id' })
  patent_id: string;
  @prop({ required: false, index: true, zh: '专利名称' })
  patent_name: string;
  @prop({ required: false, index: true, zh: '申请号' })
  crete_number: string;
  @prop({ required: false, index: true, zh: '当前权利人(变更前专利权人)' })
  on_obligee: string;
  @prop({ required: false, index: true, zh: '联系人' })
  contact: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: true, zh: '投资预算' })
  budget: string;
  @prop({
    required: false,
    index: true,
    zh: '交易类型',
    remark: '字典：patent_trans_type',
  })
  type: string;
  @prop({ required: false, index: false, zh: '免费许可承诺书' })
  promise_file: object;
  @prop({
    required: false,
    index: true,
    zh: '是否有评估报告',
    remark: '字典：common_isno',
    default: '1',
  })
  is_report: string;
  @prop({ required: false, index: false, zh: '评估报告' })
  report: Array<any>;
  @prop({ required: false, index: false, zh: '技术说明' })
  requirementdesc: string;
  @prop({ required: false, index: false, zh: '商业预期' })
  expect: string;
  @prop({ required: false, index: false, zh: '合作条件及要求' })
  condition: string;
  @prop({ required: false, index: false, zh: '摘要' })
  abstract: string;
  @prop({ required: false, index: true, zh: '变更后专利权人' })
  on_afterobligee: string;
  @prop({ required: false, index: true, zh: '专利权转移日期' })
  transfer_date: string;
  @prop({
    required: false,
    index: true,
    zh: '合同类型',
    remark: '字典:patent_trans_contract_type',
  })
  is_contract: string;
  @prop({ required: false, index: false, zh: '线下合同' })
  offine_contract: Array<any>;
  @prop({ required: false, index: false, zh: '线上合同' })
  contract: object;
  @prop({ required: false, index: false, zh: '审核记录' })
  record: Array<any>;
}
