import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_analysis {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '管理员id' })
  'admin_id': string = undefined;
  @ApiProperty({ description: '管理员姓名' })
  'admin_name': string = undefined;
  @ApiProperty({ description: '用户id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '用户姓名' })
  'user_name': string = undefined;
  @ApiProperty({ description: '发明名称' })
  'name': string = undefined;
  @ApiProperty({ description: '申请人' })
  'apply_name': string = undefined;
  @ApiProperty({ description: '专利类型' })
  'type': string = undefined;
  @ApiProperty({ description: '发明人' })
  'inventor': string = undefined;
  @ApiProperty({ description: '技术联系人' })
  'techol_contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '特殊情况说明' })
  'special': string = undefined;
  @ApiProperty({ description: '本发明的技术领域' })
  'techol_field': string = undefined;
  @ApiProperty({ description: '本发明的相关的背景技术' })
  'techol_back': string = undefined;
  @ApiProperty({ description: '现有技术的缺点及本发明所要解决的技术问题' })
  'techol_ques': string = undefined;
  @ApiProperty({ description: '本发明技术方案的详细阐述' })
  'techol_prop': string = undefined;
  @ApiProperty({ description: '本申请的关键点和预保护点' })
  'techol_prot': string = undefined;
  @ApiProperty({
    description: '本发明最相似，相近的实现技术，方案相比，本发明有何优点',
  })
  'techol_advan': string = undefined;
  @ApiProperty({ description: '针对本发明技术方案，是否还有的替代方案' })
  'techol_alter': string = undefined;
  @ApiProperty({ description: '审核记录' })
  'record': Array<any> = undefined;
  @ApiProperty({ description: '报告文件' })
  'report_file': Array<any> = undefined;
}

export class QDTO_analysis extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'status',
      'admin_id',
      'admin_name',
      'user_id',
      'user_name',
      'name',
      'apply_name',
      'type',
      'inventor',
      'techol_contact',
      'phone',
      'email',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '管理员id' })
  'admin_id': string = undefined;
  @ApiProperty({ description: '管理员姓名' })
  'admin_name': string = undefined;
  @ApiProperty({ description: '用户id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '用户姓名' })
  'user_name': string = undefined;
  @ApiProperty({ description: '发明名称' })
  'name': string = undefined;
  @ApiProperty({ description: '申请人' })
  'apply_name': string = undefined;
  @ApiProperty({ description: '专利类型' })
  'type': string = undefined;
  @ApiProperty({ description: '发明人' })
  'inventor': string = undefined;
  @ApiProperty({ description: '技术联系人' })
  'techol_contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
}

export class QVO_analysis extends FVO_analysis {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_analysis {
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '管理员id' })
  @Rule(RuleType['string']().empty(''))
  'admin_id': string = undefined;
  @ApiProperty({ description: '管理员姓名' })
  @Rule(RuleType['string']().empty(''))
  'admin_name': string = undefined;
  @ApiProperty({ description: '用户id' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @ApiProperty({ description: '用户姓名' })
  @Rule(RuleType['string']().empty(''))
  'user_name': string = undefined;
  @ApiProperty({ description: '发明名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '申请人' })
  @Rule(RuleType['string']().empty(''))
  'apply_name': string = undefined;
  @ApiProperty({ description: '专利类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '发明人' })
  @Rule(RuleType['string']().empty(''))
  'inventor': string = undefined;
  @ApiProperty({ description: '技术联系人' })
  @Rule(RuleType['string']().empty(''))
  'techol_contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: '特殊情况说明' })
  @Rule(RuleType['string']().empty(''))
  'special': string = undefined;
  @ApiProperty({ description: '本发明的技术领域' })
  @Rule(RuleType['string']().empty(''))
  'techol_field': string = undefined;
  @ApiProperty({ description: '本发明的相关的背景技术' })
  @Rule(RuleType['string']().empty(''))
  'techol_back': string = undefined;
  @ApiProperty({ description: '现有技术的缺点及本发明所要解决的技术问题' })
  @Rule(RuleType['string']().empty(''))
  'techol_ques': string = undefined;
  @ApiProperty({ description: '本发明技术方案的详细阐述' })
  @Rule(RuleType['string']().empty(''))
  'techol_prop': string = undefined;
  @ApiProperty({ description: '本申请的关键点和预保护点' })
  @Rule(RuleType['string']().empty(''))
  'techol_prot': string = undefined;
  @ApiProperty({
    description: '本发明最相似，相近的实现技术，方案相比，本发明有何优点',
  })
  @Rule(RuleType['string']().empty(''))
  'techol_advan': string = undefined;
  @ApiProperty({ description: '针对本发明技术方案，是否还有的替代方案' })
  @Rule(RuleType['string']().empty(''))
  'techol_alter': string = undefined;
  @ApiProperty({ description: '审核记录' })
  @Rule(RuleType['array']().empty(''))
  'record': Array<any> = undefined;
  @ApiProperty({ description: '报告文件' })
  @Rule(RuleType['array']().empty(''))
  'report_file': Array<any> = undefined;
}

export class CVO_analysis extends FVO_analysis {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_analysis extends CDTO_analysis {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_analysis extends FVO_analysis {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
