import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_assessment {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '管理员id' })
  'admin_id': string = undefined;
  @ApiProperty({ description: '管理员姓名' })
  'admin_name': string = undefined;
  @ApiProperty({ description: '用户id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '用户姓名' })
  'user_name': string = undefined;
  @ApiProperty({ description: '专利id' })
  'patent_id': string = undefined;
  @ApiProperty({ description: '申请号' })
  'create_number': string = undefined;
  @ApiProperty({ description: '专利名称' })
  'patent_name': string = undefined;
  @ApiProperty({ description: '发明人' })
  'inventor': string = undefined;
  @ApiProperty({ description: '专利类型' })
  'type': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '摘要' })
  'abstract': string = undefined;
  @ApiProperty({ description: '应用领域' })
  'field': string = undefined;
  @ApiProperty({ description: '技术说明' })
  'explain': string = undefined;
  @ApiProperty({ description: '合享价值度' })
  'shared_value': string = undefined;
  @ApiProperty({ description: '技术稳定性' })
  'techol_stable': string = undefined;
  @ApiProperty({ description: '技术先进性' })
  'techol_advanced': string = undefined;
  @ApiProperty({ description: '是否缴费' })
  'is_money': string = undefined;
  @ApiProperty({ description: '审核记录' })
  'record': Array<any> = undefined;
  @ApiProperty({ description: '报告文件' })
  'report_file': Array<any> = undefined;
}

export class QDTO_assessment extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'status',
      'admin_id',
      'admin_name',
      'user_id',
      'user_name',
      'patent_id',
      'create_number',
      'patent_name',
      'inventor',
      'type',
      'contact',
      'phone',
      'is_money',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '管理员id' })
  'admin_id': string = undefined;
  @ApiProperty({ description: '管理员姓名' })
  'admin_name': string = undefined;
  @ApiProperty({ description: '用户id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '用户姓名' })
  'user_name': string = undefined;
  @ApiProperty({ description: '专利id' })
  'patent_id': string = undefined;
  @ApiProperty({ description: '申请号' })
  'create_number': string = undefined;
  @ApiProperty({ description: '专利名称' })
  'patent_name': string = undefined;
  @ApiProperty({ description: '发明人' })
  'inventor': string = undefined;
  @ApiProperty({ description: '专利类型' })
  'type': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '是否缴费' })
  'is_money': string = undefined;
}

export class QVO_assessment extends FVO_assessment {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_assessment {
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '管理员id' })
  @Rule(RuleType['string']().empty(''))
  'admin_id': string = undefined;
  @ApiProperty({ description: '管理员姓名' })
  @Rule(RuleType['string']().empty(''))
  'admin_name': string = undefined;
  @ApiProperty({ description: '用户id' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @ApiProperty({ description: '用户姓名' })
  @Rule(RuleType['string']().empty(''))
  'user_name': string = undefined;
  @ApiProperty({ description: '专利id' })
  @Rule(RuleType['string']().empty(''))
  'patent_id': string = undefined;
  @ApiProperty({ description: '申请号' })
  @Rule(RuleType['string']().empty(''))
  'create_number': string = undefined;
  @ApiProperty({ description: '专利名称' })
  @Rule(RuleType['string']().empty(''))
  'patent_name': string = undefined;
  @ApiProperty({ description: '发明人' })
  @Rule(RuleType['string']().empty(''))
  'inventor': string = undefined;
  @ApiProperty({ description: '专利类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '联系人' })
  @Rule(RuleType['string']().empty(''))
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '摘要' })
  @Rule(RuleType['string']().empty(''))
  'abstract': string = undefined;
  @ApiProperty({ description: '应用领域' })
  @Rule(RuleType['string']().empty(''))
  'field': string = undefined;
  @ApiProperty({ description: '技术说明' })
  @Rule(RuleType['string']().empty(''))
  'explain': string = undefined;
  @ApiProperty({ description: '合享价值度' })
  @Rule(RuleType['string']().empty(''))
  'shared_value': string = undefined;
  @ApiProperty({ description: '技术稳定性' })
  @Rule(RuleType['string']().empty(''))
  'techol_stable': string = undefined;
  @ApiProperty({ description: '技术先进性' })
  @Rule(RuleType['string']().empty(''))
  'techol_advanced': string = undefined;
  @ApiProperty({ description: '是否缴费' })
  @Rule(RuleType['string']().empty(''))
  'is_money': string = undefined;
  @ApiProperty({ description: '审核记录' })
  @Rule(RuleType['array']().empty(''))
  'record': Array<any> = undefined;
  @ApiProperty({ description: '报告文件' })
  @Rule(RuleType['array']().empty(''))
  'report_file': Array<any> = undefined;
}

export class CVO_assessment extends FVO_assessment {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_assessment extends CDTO_assessment {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_assessment extends FVO_assessment {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
