import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_cpcMessage {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '接收人' })
  'receive_id': string = undefined;
  @ApiProperty({ description: '接收人姓名' })
  'receive_name': string = undefined;
  @ApiProperty({ description: '专利id' })
  'patent_id': string = undefined;
  @ApiProperty({ description: '申请号' })
  'create_number': string = undefined;
  @ApiProperty({ description: '专利名称' })
  'patent_name': string = undefined;
  @ApiProperty({ description: '预警信息' })
  'content': string = undefined;
  @ApiProperty({ description: '预警文件' })
  'warn_file': Array<any> = undefined;
  @ApiProperty({ description: '发送时间' })
  'send_date': string = undefined;
  @ApiProperty({ description: '是否已读' })
  'is_read': string = undefined;
}

export class QDTO_cpcMessage extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'receive_id',
      'receive_name',
      'patent_id',
      'create_number',
      'patent_name',
      'send_date',
      'is_read',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '接收人' })
  'receive_id': string = undefined;
  @ApiProperty({ description: '接收人姓名' })
  'receive_name': string = undefined;
  @ApiProperty({ description: '专利id' })
  'patent_id': string = undefined;
  @ApiProperty({ description: '申请号' })
  'create_number': string = undefined;
  @ApiProperty({ description: '专利名称' })
  'patent_name': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'send_date': string = undefined;
  @ApiProperty({ description: '是否已读' })
  'is_read': string = undefined;
}

export class QVO_cpcMessage extends FVO_cpcMessage {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_cpcMessage {
  @ApiProperty({ description: '接收人' })
  @Rule(RuleType['string']().empty(''))
  'receive_id': string = undefined;
  @ApiProperty({ description: '接收人姓名' })
  @Rule(RuleType['string']().empty(''))
  'receive_name': string = undefined;
  @ApiProperty({ description: '专利id' })
  @Rule(RuleType['string']().empty(''))
  'patent_id': string = undefined;
  @ApiProperty({ description: '申请号' })
  @Rule(RuleType['string']().empty(''))
  'create_number': string = undefined;
  @ApiProperty({ description: '专利名称' })
  @Rule(RuleType['string']().empty(''))
  'patent_name': string = undefined;
  @ApiProperty({ description: '预警信息' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '预警文件' })
  @Rule(RuleType['array']().empty(''))
  'warn_file': Array<any> = undefined;
  @ApiProperty({ description: '发送时间' })
  @Rule(RuleType['string']().empty(''))
  'send_date': string = undefined;
  @ApiProperty({ description: '是否已读' })
  @Rule(RuleType['string']().empty(''))
  'is_read': string = undefined;
}

export class CVO_cpcMessage extends FVO_cpcMessage {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_cpcMessage extends CDTO_cpcMessage {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_cpcMessage extends FVO_cpcMessage {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
