import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_cpcMessageerror {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '申请号' })
  'create_number': string = undefined;
  @ApiProperty({ description: '专利名称' })
  'patent_name': string = undefined;
  @ApiProperty({ description: '专利信息key' })
  'patent_key': string = undefined;
  @ApiProperty({ description: '错误信息' })
  'content': string = undefined;
  @ApiProperty({ description: '导入的zip包' })
  'zip_url': string = undefined;
  @ApiProperty({ description: '导入时间' })
  'create_Date': string = undefined;
}

export class QDTO_cpcMessageerror extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'create_number',
      'patent_name',
      'patent_key',
      'content',
      'create_Date',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '申请号' })
  'create_number': string = undefined;
  @ApiProperty({ description: '专利名称' })
  'patent_name': string = undefined;
  @ApiProperty({ description: '专利信息key' })
  'patent_key': string = undefined;
  @ApiProperty({ description: '错误信息' })
  'content': string = undefined;
  @ApiProperty({ description: '导入时间' })
  'create_Date': string = undefined;
}

export class QVO_cpcMessageerror extends FVO_cpcMessageerror {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_cpcMessageerror {
  @ApiProperty({ description: '申请号' })
  @Rule(RuleType['string']().empty(''))
  'create_number': string = undefined;
  @ApiProperty({ description: '专利名称' })
  @Rule(RuleType['string']().empty(''))
  'patent_name': string = undefined;
  @ApiProperty({ description: '专利信息key' })
  @Rule(RuleType['string']().empty(''))
  'patent_key': string = undefined;
  @ApiProperty({ description: '错误信息' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '导入的zip包' })
  @Rule(RuleType['string']().empty(''))
  'zip_url': string = undefined;
  @ApiProperty({ description: '导入时间' })
  @Rule(RuleType['string']().empty(''))
  'create_Date': string = undefined;
}

export class CVO_cpcMessageerror extends FVO_cpcMessageerror {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_cpcMessageerror extends CDTO_cpcMessageerror {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_cpcMessageerror extends FVO_cpcMessageerror {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
