import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_examNotice {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '发送人' })
  'send_id': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'send_date': string = undefined;
  @ApiProperty({ description: '接收人' })
  'receive_id': string = undefined;
  @ApiProperty({ description: '发送内容' })
  'content': string = undefined;
  @ApiProperty({ description: '是否已读' })
  'is_read': string = undefined;
}

export class QDTO_examNotice extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['send_id', 'send_date', 'receive_id', 'is_read'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '发送人' })
  'send_id': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'send_date': string = undefined;
  @ApiProperty({ description: '接收人' })
  'receive_id': string = undefined;
  @ApiProperty({ description: '是否已读' })
  'is_read': string = undefined;
}

export class QVO_examNotice extends FVO_examNotice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_examNotice {
  @ApiProperty({ description: '发送人' })
  @Rule(RuleType['string']().empty(''))
  'send_id': string = undefined;
  @ApiProperty({ description: '发送时间' })
  @Rule(RuleType['string']().empty(''))
  'send_date': string = undefined;
  @ApiProperty({ description: '接收人' })
  @Rule(RuleType['string']().empty(''))
  'receive_id': string = undefined;
  @ApiProperty({ description: '发送内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '是否已读' })
  @Rule(RuleType['string']().empty(''))
  'is_read': string = undefined;
}

export class CVO_examNotice extends FVO_examNotice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_examNotice extends CDTO_examNotice {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_examNotice extends FVO_examNotice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
