import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_notice {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '发送人类型' })
  'send_type': string = undefined;
  @ApiProperty({ description: '发送人' })
  'send_id': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'send_date': string = undefined;
  @ApiProperty({ description: '接收人类型' })
  'type': string = undefined;
  @ApiProperty({ description: '接收人' })
  'receive': Array<any> = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '通知文件' })
  'annex_file': Array<any> = undefined;
}

export class QDTO_notice extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['send_type', 'send_id', 'send_date', 'type'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '发送人类型' })
  'send_type': string = undefined;
  @ApiProperty({ description: '发送人' })
  'send_id': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'send_date': string = undefined;
  @ApiProperty({ description: '接收人类型' })
  'type': string = undefined;
}

export class QVO_notice extends FVO_notice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_notice {
  @ApiProperty({ description: '发送人类型' })
  @Rule(RuleType['string']().empty(''))
  'send_type': string = undefined;
  @ApiProperty({ description: '发送人' })
  @Rule(RuleType['string']().empty(''))
  'send_id': string = undefined;
  @ApiProperty({ description: '发送时间' })
  @Rule(RuleType['string']().empty(''))
  'send_date': string = undefined;
  @ApiProperty({ description: '接收人类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '接收人' })
  @Rule(RuleType['array']().empty(''))
  'receive': Array<any> = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '通知文件' })
  @Rule(RuleType['array']().empty(''))
  'annex_file': Array<any> = undefined;
}

export class CVO_notice extends FVO_notice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_notice extends CDTO_notice {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_notice extends FVO_notice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
