import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_patent {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '申请号' })
  'create_number': string = undefined;
  @ApiProperty({ description: '申请日' })
  'create_date': string = undefined;
  @ApiProperty({ description: '公开(公告)号' })
  'success_number': string = undefined;
  @ApiProperty({ description: '公开(公告)日' })
  'success_date': string = undefined;
  @ApiProperty({ description: '发明人' })
  'inventor': string = undefined;
  @ApiProperty({ description: '代理机构' })
  'agent': string = undefined;
  @ApiProperty({ description: '代理人' })
  'agent_personal': string = undefined;
  @ApiProperty({ description: '摘要(中文)' })
  'abstract': string = undefined;
  @ApiProperty({ description: '发明人地址' })
  'address': string = undefined;
  @ApiProperty({ description: '标题(中文)' })
  'name': string = undefined;
  @ApiProperty({ description: '申请人' })
  'apply_personal': string = undefined;
  @ApiProperty({ description: '专利有效性' })
  'term': string = undefined;
  @ApiProperty({ description: '专利类型' })
  'type': string = undefined;
  @ApiProperty({ description: '首页附图(压缩图)' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '公开国别' })
  'nationality': string = undefined;
  @ApiProperty({ description: 'IPC主分类' })
  'ipc_type': string = undefined;
  @ApiProperty({ description: '当前法律状态' })
  'onlegal_status': string = undefined;
  @ApiProperty({ description: '法律状态' })
  'legal_status': string = undefined;
  @ApiProperty({ description: '法律文书日期' })
  'law_date': string = undefined;
  @ApiProperty({ description: '当前权利人' })
  'on_obligee': string = undefined;
  @ApiProperty({ description: '申请人地址(其他)' })
  'apply_address': string = undefined;
  @ApiProperty({ description: '申请人(其他)' })
  'apply_other': string = undefined;
  @ApiProperty({ description: '法律文书编号' })
  'law_num': string = undefined;
  @ApiProperty({ description: '首次公开日' })
  'first_opendate': string = undefined;
  @ApiProperty({ description: '授权公告日' })
  'empower_date': string = undefined;
  @ApiProperty({ description: '失效日' })
  'lose_date': string = undefined;
  @ApiProperty({ description: '实质审查生效日' })
  'examine_date': string = undefined;
  @ApiProperty({ description: '发明(设计)人(其他)' })
  'invention_design': string = undefined;
  @ApiProperty({ description: '链接到incoPat' })
  'incopat_link': string = undefined;
  @ApiProperty({ description: '首项权利要求' })
  'first_ask': string = undefined;
  @ApiProperty({ description: '第一申请人' })
  'first_apply': string = undefined;
  @ApiProperty({ description: '中国申请人城市' })
  'apply_city': string = undefined;
  @ApiProperty({ description: '工商统一社会信用代码' })
  'business_code': string = undefined;
  @ApiProperty({ description: '工商注册地' })
  'business_address': string = undefined;
  @ApiProperty({ description: '第一发明人' })
  'first_inventor': string = undefined;
  @ApiProperty({ description: '合享价值度' })
  'shared_value': string = undefined;
  @ApiProperty({ description: '技术稳定性' })
  'techol_stable': string = undefined;
  @ApiProperty({ description: '技术先进性' })
  'techol_advanced': string = undefined;
  @ApiProperty({ description: 'PCT国际申请号' })
  'pct_apply': string = undefined;
  @ApiProperty({ description: 'PCT国际公布号' })
  'pct_publish': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '交易状态' })
  'trans_status': string = undefined;
  @ApiProperty({ description: '专利关联人' })
  'users': Array<any> = undefined;
}

export class QDTO_patent extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'create_number',
      'create_date',
      'success_number',
      'success_date',
      'inventor',
      'address',
      'name',
      'apply_personal',
      'term',
      'type',
      'first_apply',
      'first_inventor',
      'status',
      'trans_status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '申请号' })
  'create_number': string = undefined;
  @ApiProperty({ description: '申请日' })
  'create_date': string = undefined;
  @ApiProperty({ description: '公开(公告)号' })
  'success_number': string = undefined;
  @ApiProperty({ description: '公开(公告)日' })
  'success_date': string = undefined;
  @ApiProperty({ description: '发明人' })
  'inventor': string = undefined;
  @ApiProperty({ description: '发明人地址' })
  'address': string = undefined;
  @ApiProperty({ description: '标题(中文)' })
  'name': string = undefined;
  @ApiProperty({ description: '申请人' })
  'apply_personal': string = undefined;
  @ApiProperty({ description: '专利有效性' })
  'term': string = undefined;
  @ApiProperty({ description: '专利类型' })
  'type': string = undefined;
  @ApiProperty({ description: '第一申请人' })
  'first_apply': string = undefined;
  @ApiProperty({ description: '第一发明人' })
  'first_inventor': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '交易状态' })
  'trans_status': string = undefined;
}

export class QVO_patent extends FVO_patent {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_patent {
  @ApiProperty({ description: '申请号' })
  @Rule(RuleType['string']().empty(''))
  'create_number': string = undefined;
  @ApiProperty({ description: '申请日' })
  @Rule(RuleType['string']().empty(''))
  'create_date': string = undefined;
  @ApiProperty({ description: '公开(公告)号' })
  @Rule(RuleType['string']().empty(''))
  'success_number': string = undefined;
  @ApiProperty({ description: '公开(公告)日' })
  @Rule(RuleType['string']().empty(''))
  'success_date': string = undefined;
  @ApiProperty({ description: '发明人' })
  @Rule(RuleType['string']().empty(''))
  'inventor': string = undefined;
  @ApiProperty({ description: '代理机构' })
  @Rule(RuleType['string']().empty(''))
  'agent': string = undefined;
  @ApiProperty({ description: '代理人' })
  @Rule(RuleType['string']().empty(''))
  'agent_personal': string = undefined;
  @ApiProperty({ description: '摘要(中文)' })
  @Rule(RuleType['string']().empty(''))
  'abstract': string = undefined;
  @ApiProperty({ description: '发明人地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '标题(中文)' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '申请人' })
  @Rule(RuleType['string']().empty(''))
  'apply_personal': string = undefined;
  @ApiProperty({ description: '专利有效性' })
  @Rule(RuleType['string']().empty(''))
  'term': string = undefined;
  @ApiProperty({ description: '专利类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '首页附图(压缩图)' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '公开国别' })
  @Rule(RuleType['string']().empty(''))
  'nationality': string = undefined;
  @ApiProperty({ description: 'IPC主分类' })
  @Rule(RuleType['string']().empty(''))
  'ipc_type': string = undefined;
  @ApiProperty({ description: '当前法律状态' })
  @Rule(RuleType['string']().empty(''))
  'onlegal_status': string = undefined;
  @ApiProperty({ description: '法律状态' })
  @Rule(RuleType['string']().empty(''))
  'legal_status': string = undefined;
  @ApiProperty({ description: '法律文书日期' })
  @Rule(RuleType['string']().empty(''))
  'law_date': string = undefined;
  @ApiProperty({ description: '当前权利人' })
  @Rule(RuleType['string']().empty(''))
  'on_obligee': string = undefined;
  @ApiProperty({ description: '申请人地址(其他)' })
  @Rule(RuleType['string']().empty(''))
  'apply_address': string = undefined;
  @ApiProperty({ description: '申请人(其他)' })
  @Rule(RuleType['string']().empty(''))
  'apply_other': string = undefined;
  @ApiProperty({ description: '法律文书编号' })
  @Rule(RuleType['string']().empty(''))
  'law_num': string = undefined;
  @ApiProperty({ description: '首次公开日' })
  @Rule(RuleType['string']().empty(''))
  'first_opendate': string = undefined;
  @ApiProperty({ description: '授权公告日' })
  @Rule(RuleType['string']().empty(''))
  'empower_date': string = undefined;
  @ApiProperty({ description: '失效日' })
  @Rule(RuleType['string']().empty(''))
  'lose_date': string = undefined;
  @ApiProperty({ description: '实质审查生效日' })
  @Rule(RuleType['string']().empty(''))
  'examine_date': string = undefined;
  @ApiProperty({ description: '发明(设计)人(其他)' })
  @Rule(RuleType['string']().empty(''))
  'invention_design': string = undefined;
  @ApiProperty({ description: '链接到incoPat' })
  @Rule(RuleType['string']().empty(''))
  'incopat_link': string = undefined;
  @ApiProperty({ description: '首项权利要求' })
  @Rule(RuleType['string']().empty(''))
  'first_ask': string = undefined;
  @ApiProperty({ description: '第一申请人' })
  @Rule(RuleType['string']().empty(''))
  'first_apply': string = undefined;
  @ApiProperty({ description: '中国申请人城市' })
  @Rule(RuleType['string']().empty(''))
  'apply_city': string = undefined;
  @ApiProperty({ description: '工商统一社会信用代码' })
  @Rule(RuleType['string']().empty(''))
  'business_code': string = undefined;
  @ApiProperty({ description: '工商注册地' })
  @Rule(RuleType['string']().empty(''))
  'business_address': string = undefined;
  @ApiProperty({ description: '第一发明人' })
  @Rule(RuleType['string']().empty(''))
  'first_inventor': string = undefined;
  @ApiProperty({ description: '合享价值度' })
  @Rule(RuleType['string']().empty(''))
  'shared_value': string = undefined;
  @ApiProperty({ description: '技术稳定性' })
  @Rule(RuleType['string']().empty(''))
  'techol_stable': string = undefined;
  @ApiProperty({ description: '技术先进性' })
  @Rule(RuleType['string']().empty(''))
  'techol_advanced': string = undefined;
  @ApiProperty({ description: 'PCT国际申请号' })
  @Rule(RuleType['string']().empty(''))
  'pct_apply': string = undefined;
  @ApiProperty({ description: 'PCT国际公布号' })
  @Rule(RuleType['string']().empty(''))
  'pct_publish': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '交易状态' })
  @Rule(RuleType['string']().empty(''))
  'trans_status': string = undefined;
  @ApiProperty({ description: '专利关联人' })
  @Rule(RuleType['array']().empty(''))
  'users': Array<any> = undefined;
}

export class CVO_patent extends FVO_patent {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_patent extends CDTO_patent {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_patent extends FVO_patent {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class ImportDTO {
  @ApiProperty({ description: 'url地址', example: '' })
  @Rule(RuleType['string']().empty(''))
  'url': string = undefined;
  @ApiProperty({ description: '验证码', example: '' })
  @Rule(RuleType['string']().empty(''))
  'code': string = undefined;
}
export class ExportDTO {
  @ApiProperty({ description: 'file', example: [] })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '条件', example: '' })
  @Rule(RuleType['string']().empty(''))
  'filter': string = undefined;
  @ApiProperty({ description: '开始条数', example: '' })
  @Rule(RuleType['string']().empty(''))
  'start_num': string = undefined;
  @ApiProperty({ description: '结束条数', example: '' })
  @Rule(RuleType['string']().empty(''))
  'end_num': string = undefined;
}
export class updateUserDTO {
  @ApiProperty({ description: '数组', example: [] })
  @Rule(RuleType['array']().empty(''))
  'list': Array<any> = undefined;
  @ApiProperty({ description: '用户id', example: '' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @ApiProperty({ description: '名字', example: '' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
}
