import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_techol {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '需求订单号' })
  'order_num': string = undefined;
  @ApiProperty({ description: '需求描述（用途）' })
  'describe': string = undefined;
  @ApiProperty({ description: '紧急程度' })
  'urgent': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '合作条件及要求' })
  'requirement': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_techol extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'order_num',
      'describe',
      'urgent',
      'contact',
      'phone',
      'email',
      'status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '需求订单号' })
  'order_num': string = undefined;
  @ApiProperty({ description: '需求描述（用途）' })
  'describe': string = undefined;
  @ApiProperty({ description: '紧急程度' })
  'urgent': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_techol extends FVO_techol {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_techol {
  @ApiProperty({ description: '需求订单号' })
  @Rule(RuleType['string']().empty(''))
  'order_num': string = undefined;
  @ApiProperty({ description: '需求描述（用途）' })
  @Rule(RuleType['string']().empty(''))
  'describe': string = undefined;
  @ApiProperty({ description: '紧急程度' })
  @Rule(RuleType['string']().empty(''))
  'urgent': string = undefined;
  @ApiProperty({ description: '联系人' })
  @Rule(RuleType['string']().empty(''))
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: '合作条件及要求' })
  @Rule(RuleType['string']().empty(''))
  'requirement': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_techol extends FVO_techol {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_techol extends CDTO_techol {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_techol extends FVO_techol {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
